/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreLogicandgrp.TCoreLogicandgrpPath;
import de.ship.db.tables.records.TCoreLogiccondRecord;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreLogiccond extends TableImpl<TCoreLogiccondRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_logiccond</code>
     */
    public static final TCoreLogiccond T_CORE_LOGICCOND = new TCoreLogiccond();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreLogiccondRecord> getRecordType() {
        return TCoreLogiccondRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_logiccond.pk_core_logiccond</code>.
     */
    public final TableField<TCoreLogiccondRecord, Integer> PK_CORE_LOGICCOND = createField(DSL.name("pk_core_logiccond"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_logiccond.fk_andgrp</code>.
     */
    public final TableField<TCoreLogiccondRecord, Integer> FK_ANDGRP = createField(DSL.name("fk_andgrp"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_logiccond.fk_variable</code>.
     */
    public final TableField<TCoreLogiccondRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_logiccond.depth</code>.
     */
    public final TableField<TCoreLogiccondRecord, Integer> DEPTH = createField(DSL.name("depth"), SQLDataType.INTEGER.nullable(false).defaultValue(DSL.field(DSL.raw("1"), SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>common_dd.t_core_logiccond.logiccond_value</code>. value
     * of logical condition (if is not variable)
     */
    public final TableField<TCoreLogiccondRecord, BigDecimal> LOGICCOND_VALUE = createField(DSL.name("logiccond_value"), SQLDataType.NUMERIC, this, "value of logical condition (if is not variable)");

    /**
     * The column <code>common_dd.t_core_logiccond.fk_variable2</code>. value of
     * logical condition (if is variable)
     */
    public final TableField<TCoreLogiccondRecord, Integer> FK_VARIABLE2 = createField(DSL.name("fk_variable2"), SQLDataType.INTEGER, this, "value of logical condition (if is variable)");

    /**
     * The column <code>common_dd.t_core_logiccond.depth2</code>.
     */
    public final TableField<TCoreLogiccondRecord, Integer> DEPTH2 = createField(DSL.name("depth2"), SQLDataType.INTEGER.nullable(false).defaultValue(DSL.field(DSL.raw("1"), SQLDataType.INTEGER)), this, "");

    /**
     * The column <code>common_dd.t_core_logiccond.logiccond_comparator</code>.
     * comparator; may be =, !=, &gt;, &lt;, &gt;=, &lt;=, is null, is not null
     */
    public final TableField<TCoreLogiccondRecord, String> LOGICCOND_COMPARATOR = createField(DSL.name("logiccond_comparator"), SQLDataType.CLOB.nullable(false), this, "comparator; may be =, !=, >, <, >=, <=, is null, is not null");

    /**
     * The column <code>common_dd.t_core_logiccond.compare_variables</code>. use
     * fk_variable2 (= 1) or logiccond_value (= 0)
     */
    public final TableField<TCoreLogiccondRecord, Integer> COMPARE_VARIABLES = createField(DSL.name("compare_variables"), SQLDataType.INTEGER.nullable(false), this, "use fk_variable2 (= 1) or logiccond_value (= 0)");

    /**
     * The column <code>common_dd.t_core_logiccond.lastchange</code>.
     */
    public final TableField<TCoreLogiccondRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    private TCoreLogiccond(Name alias, Table<TCoreLogiccondRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreLogiccond(Name alias, Table<TCoreLogiccondRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logiccond</code> table reference
     */
    public TCoreLogiccond(String alias) {
        this(DSL.name(alias), T_CORE_LOGICCOND);
    }

    /**
     * Create an aliased <code>common_dd.t_core_logiccond</code> table reference
     */
    public TCoreLogiccond(Name alias) {
        this(alias, T_CORE_LOGICCOND);
    }

    /**
     * Create a <code>common_dd.t_core_logiccond</code> table reference
     */
    public TCoreLogiccond() {
        this(DSL.name("t_core_logiccond"), null);
    }

    public <O extends Record> TCoreLogiccond(Table<O> path, ForeignKey<O, TCoreLogiccondRecord> childPath, InverseForeignKey<O, TCoreLogiccondRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_LOGICCOND);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreLogiccondPath extends TCoreLogiccond implements Path<TCoreLogiccondRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreLogiccondPath(Table<O> path, ForeignKey<O, TCoreLogiccondRecord> childPath, InverseForeignKey<O, TCoreLogiccondRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreLogiccondPath(Name alias, Table<TCoreLogiccondRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreLogiccondPath as(String alias) {
            return new TCoreLogiccondPath(DSL.name(alias), this);
        }

        @Override
        public TCoreLogiccondPath as(Name alias) {
            return new TCoreLogiccondPath(alias, this);
        }

        @Override
        public TCoreLogiccondPath as(Table<?> alias) {
            return new TCoreLogiccondPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_CORE_LOGICCOND_FK_ANDGRP, Indexes.IDX_CORE_LOGICCOND_FK_VARIABLE, Indexes.IDX_CORE_LOGICCOND_FK_VARIABLE2);
    }

    @Override
    public Identity<TCoreLogiccondRecord, Integer> getIdentity() {
        return (Identity<TCoreLogiccondRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreLogiccondRecord> getPrimaryKey() {
        return Keys.PK_CORE_LOGICCOND;
    }

    @Override
    public List<ForeignKey<TCoreLogiccondRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_LOGICCOND__FK_COND_ANDGRP, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE2);
    }

    private transient TCoreLogicandgrpPath _tCoreLogicandgrp;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_logicandgrp</code> table.
     */
    public TCoreLogicandgrpPath tCoreLogicandgrp() {
        if (_tCoreLogicandgrp == null)
            _tCoreLogicandgrp = new TCoreLogicandgrpPath(this, Keys.T_CORE_LOGICCOND__FK_COND_ANDGRP, null);

        return _tCoreLogicandgrp;
    }

    private transient TCoreElementHierarchyPath _fkCondVariable;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_cond_variable</code> key.
     */
    public TCoreElementHierarchyPath fkCondVariable() {
        if (_fkCondVariable == null)
            _fkCondVariable = new TCoreElementHierarchyPath(this, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE, null);

        return _fkCondVariable;
    }

    private transient TCoreElementHierarchyPath _fkCondVariable2;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>fk_cond_variable2</code> key.
     */
    public TCoreElementHierarchyPath fkCondVariable2() {
        if (_fkCondVariable2 == null)
            _fkCondVariable2 = new TCoreElementHierarchyPath(this, Keys.T_CORE_LOGICCOND__FK_COND_VARIABLE2, null);

        return _fkCondVariable2;
    }

    @Override
    public TCoreLogiccond as(String alias) {
        return new TCoreLogiccond(DSL.name(alias), this);
    }

    @Override
    public TCoreLogiccond as(Name alias) {
        return new TCoreLogiccond(alias, this);
    }

    @Override
    public TCoreLogiccond as(Table<?> alias) {
        return new TCoreLogiccond(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiccond rename(String name) {
        return new TCoreLogiccond(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiccond rename(Name name) {
        return new TCoreLogiccond(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreLogiccond rename(Table<?> name) {
        return new TCoreLogiccond(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond where(Condition condition) {
        return new TCoreLogiccond(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiccond where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiccond where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiccond where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreLogiccond where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreLogiccond whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
